--Daniel Kluss(xerox_irs@lvcm.com) Registered Euphoria User Since December 2000

global function FTP_USER(sequence in)
        --username?
        return 230
end function

global function FTP_QUIT(sequence in)
        --close the connection?
        return 221
end function

global function FTP_PORT(sequence in)
        sequence con,temp
        ? in
        con={}
        temp={}
        for i = 1 to length(in) do
                if in[i]=',' then con&={temp} temp={} else temp&=in[i] end if
        end for
        return 501
end function

global function FTP_TYPE(sequence in)
        object first,second
        if length(in)=0 then return 501 end if
        second=0
        first=0
        if in[1]='A' then first='A'--ascii
        elsif in[1]='E' then first='E'--EBCDIC
        elsif in[1]='I' then first='I'--image binary data
        elsif in[1]='L' then
                first='L'--local format
                if length(in)>=3 then
                        second=value(in[3..length(in)])
                        second=second[2]
                else
                        return 501
                end if
        else return 501
        end if
        if (first='A' or first='E') and length(in)>=3 then
                if in[3]='N' then second='N'--non-print
                elsif in[3]='T' then second='T'--telnet format
                elsif in[3]='C' then second='C'--ASA Carriage Control
                else return 501 end if
        end if
        return 200
end function

global function FTP_MODE(sequence in)
        atom mode
        if length(in)=0 then return 501 end if
        if in[1]='S' then mode='S'--Streaming
        elsif in[1]='B' then mode='B'--block
        elsif in[1]='C' then mode='C'--compressed
        else return 501 end if
        return 200
end function

global function FTP_STRU(sequence in)
        atom mode
        if length(in)=0 then return 501 end if
        if in[1]='F' then mode='F'--File(no structure)
        elsif in[1]='R' then mode='R'--Record structure
        elsif in[1]='P' then mode='P'--Page Structure
        else return 501 end if
        return 200
end function


global function FTP_ACCEPT(sequence in)
        return 120
end function

global function FTP_PASS(sequence in)
        --will take pass later?
        return 230
end function

global function FTP_ACCT(sequence in)
        --will take acct later?
        return 230
end function

global function FTP_CWD(sequence in)
        --will take directory later?
        --change directory to in
        return 250
end function

global function FTP_CDUP(sequence in)
        --up directory
        return 200
end function

global function FTP_SMNT(sequence in)
        --
        return 202
end function

global function FTP_REIN(sequence in)
        --restart the login process
        return 120
end function

global function FTP_PASV(sequence in)
        --open port on me, and return it
        return 227
end function

global function FTP_RETR(sequence in)
        --get data from the path in
        --expect a pasv/port
        return 125
end function

global function FTP_STOR(sequence in)
        --send data path in
        --expect a pasv/port
        return 125
end function

global function FTP_STOU(sequence in)
        --send data no path, make unique name
        --expect a pasv/port
        return 125
end function

global function FTP_APPE(sequence in)
        --append data path in
        --expect a pasv/port
        return 125
end function

global function FTP_ALLO(sequence in)
        object size,max_size
        if length(in)=0 then return 501 end if
        size=0
        max_size=0
        for i = 1 to length(in) do
                if i=32 and size=0 then size=value(in) size=size[2] in=in[i..length(in)] exit end if
                if i=length(in) then size=value(in) size=size[2] in={} exit end if
        end for
        if match(" R ",in)=1 and length(in)>=4 then max_size=value(in[4..length(in)]) max_size=max_size[2] end if
        --allocate this size?
        return 200
end function

global function FTP_REST(sequence in)
        object ptr
        if length(in)=0 then return 501 end if
        ptr=value(in)
        ptr=ptr[2]
        --set this to file pointer
        return 500
end function

global function FTP_RNFR(sequence in)
        --rename from
        return 450
end function

global function FTP_RNTO(sequence in)
        --rename to
        return 250
end function

global function FTP_ABOR(sequence in)
        --abort the file in progress
        return 225
end function

global function FTP_DELE(sequence in)
        --Deletes the in file on the host
        return 250
end function

global function FTP_RMD(sequence in)
        --deletes the directory
        return 250
end function

global function FTP_MKD(sequence in)
        --make directory
        return 257
end function

global function FTP_PWD(sequence in)
        --rename the name of the current directory on the host
        return 257
end function

global function FTP_LIST(sequence in)
        --must be preseded by pasv/port
        --sends a listing of directory(default)/file
        return 125
end function

global function FTP_NLST(sequence in)
        --must be preseded by pasv/port
        --sends a listing of the directory
        return 125
end function

global function FTP_SITE(sequence in)
        --executes a site specific command
        return 200
end function

global function FTP_SYST(sequence in)
        --return the system type
        return 215
end function

global function FTP_STAT(sequence in)
        --in={} returns the general status info about the ftp process
        --else acks like list, but over the control channel
        return 211
end function

global function FTP_HELP(sequence in)
        --in={} returns general help, of list of all commands
        --returns help on the one specific command
        return 211
end function

global function FTP_NOOP(sequence in)
        --does nothing execpt return a responce
        return 200
end function






--type ascii non print
--mode stream
--structure file,record
--commands user,quit,port,type,mode,stru,retr,stor,noop,list

        --state(abrt,noop),
        --transger(mode,pasv,port,REST,RETR,STOR,STOU,STRU,TYPE)
        --account(acct,pass,REIN,USER)
        --space alotted(alot)
        --current file(appe,dele,LIST,mdtm,RNFR,RNTO,SIZE,STAT)
        --current directory(cdup,cwd,LIST,mdtm,mkd,NLST,pwd,RMD,STAT)
        --help(help,SITE,SYST)

