--Daniel Kluss(xerox_irs@lvcm.com) Registered Euphoria User Since December 2000
include file.e
include mime.e
include whole.e
global function insert(sequence a,object b,atom s,atom e)
        object beg,en
        if s=1 then beg={}
        elsif s=2 then beg=a[1]
        else beg=a[1..s-1] end if
        if e=length(a) then en={}
        elsif e=(length(a)-1) then en=a[length(a)]
        else en=a[e+1..length(a)] end if
        return beg&b&en
end function

global function backward_match(sequence a,sequence b,atom d)
        atom c
        c=0
        for i = d to length(a)+1 by -1 do 
                if equal(a,b[i-length(a)+1..i]) then c=i exit end if
        end for
        return c
end function
global function multi_find(sequence a,sequence b)
        sequence ret
        ret={}
        for i = 1 to length(b)-length(a) do
                if equal(a,b[i..i+length(a)-1]) then ret&=i end if
        end for
        return ret
end function

global function match2(sequence a,sequence b,atom c)
        for i = c to length(b)-length(a) do
                if equal(a,b[i..i+length(a)-1]) then return i end if
        end for
        return 0
end function

global function clean_url(sequence url)
        object a,b
        for i = 1 to length(url) do
                a={match("//",url),match("/..",url),match("/.",url),match("..",url)}
                if a[1] then a=a[1] url=insert(url,'/',a,a+1)
                elsif a[2] then a=a[2] 
                        b=backward_match("/",url,a-1)
                        if b then url=url[1..b]
                        else url=insert(url,'/',a,a+2) end if
                elsif a[3] then a=a[3] 
                        b=backward_match("/",url,a-1)
                        if b then url=url[1..b]
                        else url=insert(url,'/',a,a+1) end if
                elsif a[4] then a=a[4] 
                        b=backward_match("/",url,a-1)
                        if b then url=url[1..b]
                        else url=insert(url,{},a,a+1) end if
                end if
        end for
        return url
end function

global function get_url(sequence data)
        sequence url
        atom a
        url="/"
        for i = 6 to length(data) do
                if find(data[i],{32,'?','*'}) then url=data[5..i-1] exit end if
        end for
        return clean_url(url)
end function

global function get_query(sequence data)
        sequence url
        atom a
        url="/"
        for i = 6 to length(data) do
                if find(data[i],{32,'*'}) then url=data[5..i-1] exit end if
        end for
        a=find('?',url)
        if a then return url[a+1..length(url)] else return {} end if
end function

global function get_host(sequence data)
        atom a
        sequence host,hosts
        hosts=value(read_whole_file("hosts.txt"))
        if hosts[1] !=GET_SUCCESS or atom(hosts[2]) then puts(2,"Major error, no hosts.txt made!!!\n") return -1 end if
        hosts=hosts[2]
        host={}
        a=match("Host: ",data)
        if a then
                for i = a+6 to length(data) do
                        if data[i]=10 or data[i]=13 or data[i]=':' then host=data[a+6..i-1] exit end if
                end for
        end if
        for i = 1 to length(hosts) do
                if sequence(hosts[i]) and length(hosts[i])=2 then
                        if equal(host,hosts[i][1]) then return hosts[i][2] end if
                end if
        end for
        return -1
end function

global function get_url_info(sequence url,sequence host)
        atom i
        object temp,temp2
        i=1
        temp={}
        temp2={}
        for ii = 1 to length(host) do
                if host[ii]='.' then temp2=temp&'\\'&temp2 temp={}
                else
                temp&=host[ii]
                end if
        end for
        url=host&url
        while 1 do
        if i>length(url) then exit end if
        if url[i]='/' then url[i]='\\'
        elsif url[i]='%' then temp=value('#'&upper(url[i+1..i+2])) url=insert(url,temp,i,i+2)
        end if
        if i>1 and equal(url[i-1..i],"\\\\") then url=insert(url,'\\',i-1,i) end if
        i+=1
        end while
        return dir("web\\"&url)
end function

global function open_url(sequence url,sequence host)
        atom i
        object temp,temp2,fa
        i=1
        temp={}
        temp2={}
        for ii = 1 to length(host) do
                if host[ii]='.' then temp2=temp&'\\'&temp2 temp={}
                else
                temp&=host[ii]
                end if
        end for
--        url=&url
        fa=host
        while 1 do
                if i>length(url) then exit end if
                if url[i]='/' then if fa[length(fa)] !='\\' then fa&='\\' end if
                elsif url[i]='%' then
                        temp=value('#'&upper(url[i+1..i+2]))
                        fa&=temp[2] i+=2
                else fa&=url[i]
                end if
                i+=1 
        end while
        url=fa

        if length(url)>255 then return (-1) end if
        i=open(url,"rb")
--        i=CreateFile(url,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0)
        return i
end function

global function get_file_url(sequence url,sequence host)
        atom i
        object temp,temp2,fa
        i=1
        temp={}
        temp2={}
        for ii = 1 to length(host) do
                if host[ii]='.' then temp2=temp&'\\'&temp2 temp={}
                else
                temp&=host[ii]
                end if
        end for
--        url=&url
        fa=host
        while 1 do
                if i>length(url) then exit end if
                if url[i]='/' then if fa[length(fa)] !='\\' then fa&='\\' end if
                elsif url[i]='%' then
                        temp=value('#'&upper(url[i+1..i+2]))
                        fa&=temp[2] i+=2
                else fa&=url[i]
                end if
                i+=1 
        end while
        url=fa

--        if length(url)>255 then return (-1) end if
--        i=open(url,"rb")
--        i=CreateFile(url,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0)
        return url
end function

global function dir_url(sequence url,sequence host)
        atom i
        object temp,temp2,fa
        i=1
        temp={}
        temp2={}
        for ii = 1 to length(host) do
                if host[ii]='.' then temp2=temp&'\\'&temp2 temp={}
                else
                temp&=host[ii]
                end if
        end for
--        url=&url
        fa=host
        while 1 do
                if i>length(url) then exit end if
                if url[i]='/' then if fa[length(fa)] !='\\' then fa&='\\' end if
                elsif url[i]='%' then
                        temp=value('#'&upper(url[i+1..i+2]))
                        fa&=temp[2] i+=2
                else fa&=url[i]
                end if
                i+=1 
        end while
        url=fa

        if length(url)>255 then return (-1) end if
        return dir(url)
end function

global function get_range(sequence data)
        atom a
        object start, finish
        a=match("Range: bytes=",data)
        if a then
                for i = a+13 to length(data) do
                        if data[i]=10 or data[i]=13 or data[i]=':' then data=data[a+13..i-1] exit elsif i=length(data) then return -1 end if
                end for
        else return -1
        end if
        a=find('-',data)
        if a<2 then return -1 end if
        start=value(data[1..a-1])
        if start[1]=GET_SUCCESS and integer(start[2]) then start=start[2] else return -1 end if
        if length(data)>a then
                finish=value(data[a+1..length(data)])
                if finish[1]=GET_SUCCESS and integer(finish[2]) then finish=finish[2] else return {start} end if
        else
                return {start}
        end if
        return {start,finish}
end function

